const { defineConfig } = require('@vue/cli-service')
const isProduction = process.env.NODE_ENV === 'production';
const isDev = process.env.NODE_ENV === 'development';

module.exports = defineConfig({
    lintOnSave: process.env.NODE_ENV !== 'production',
    productionSourceMap: false,
    publicPath: '/',
    devServer: {
        https: true,
    //     proxy: {
    //         '/api': {
    //             target: process.env.VUE_APP_PROXY,
    //             changeOrigin: true,
    //             secure: false,
    //             pathRewrite: {
    //                 '^/api': process.env.VUE_APP_PROXY_REWRITE
    //             }
    //         },
    //     },
    },
    configureWebpack: {
        output: {
            libraryExport: 'default'
        }
    },
    chainWebpack: (config) => {
        config.module
            .rule('bpmn')
            .test(/\.bpmn$/)
            .use('raw-loader')
            .loader('raw-loader')
            .end();
        config.when(isDev, config => {
            config
                .entry('app')
                .clear()
                .add('./src/main.js');
            config.plugin('html')
                .tap((args) => {
                    args[0].baseUrl = process.env['VUE_APP_STATIC'];
                    args[0].isProd = false;
                    args[0].imWs = process.env['VUE_APP_IM_WS'];
                    args[0].log = process.env['VUE_APP_LOGADDRESS'];
                    return args;
                });
        });
        config.when(isProduction, config => {
            config
                .entry('app')
                .clear()
                .add('./src/main.js');
            config.plugin('html')
                .tap((args) => {
                    args[0].baseUrl = process.env['VUE_APP_STATIC'];
                    args[0].isProd = true;
                    args[0].imWs = process.env['VUE_APP_IM_WS'];
                    args[0].log = process.env['VUE_APP_LOGADDRESS'];
                    return args;
                });
        });
    },
})